From 9cf1cd92ccab54ce7580a645ba2bd104e431dc36 Mon Sep 17 00:00:00 2001
From: FateJH <Jason_DiDonato@yahoo.com>
Date: Thu, 6 Jun 2019 14:54:53 -0400
Subject: [PATCH 07/31] communication of the details information for a squad
 and refactored messaging back to WSA; removed an unused description field
 from the squad and added two fields that were actually represented

---
 .../psforever/objects/teamwork/Squad.scala    |  41 +-
 .../game/SquadDefinitionActionMessage.scala   |  28 +-
 .../SquadDetailDefinitionUpdateMessage.scala  |   2 +
 .../packet/game/SquadMembershipRequest.scala  |   2 +-
 .../services/teamwork/SquadResponse.scala     |   4 +-
 .../services/teamwork/SquadService.scala      | 472 ++++++++++++------
 .../teamwork/SquadServiceMessage.scala        |   4 +-
 .../SquadDefinitionActionMessageTest.scala    | 100 ++--
 .../src/main/scala/WorldSessionActor.scala    |  76 +--
 9 files changed, 467 insertions(+), 262 deletions(-)

diff --git a/common/src/main/scala/net/psforever/objects/teamwork/Squad.scala b/common/src/main/scala/net/psforever/objects/teamwork/Squad.scala
index 4ac3cfc2..21a48cb3 100644
--- a/common/src/main/scala/net/psforever/objects/teamwork/Squad.scala
+++ b/common/src/main/scala/net/psforever/objects/teamwork/Squad.scala
@@ -10,18 +10,21 @@ class Squad(squadId : PlanetSideGUID, alignment : PlanetSideEmpire.Value) extend
   private val faction : PlanetSideEmpire.Value = alignment //does not change
   private var zoneId : Option[Int] = None
   private var task : String = ""
-  private var description : String = ""
   private val membership : Array[Member] = Array.fill[Member](10)(new Member)
   private val availability : Array[Boolean] = Array.fill[Boolean](10)(true)
   private var listed : Boolean = false
   private var leaderPositionIndex : Int = 0
+  private var autoApproveInvitationRequests : Boolean = false
+  private var locationFollowsSquadLead : Boolean = false
 
   override def GUID_=(d : PlanetSideGUID) : PlanetSideGUID = GUID
 
   def Faction : PlanetSideEmpire.Value = faction
 
+  def CustomZoneId : Boolean = zoneId.isDefined
+
   def ZoneId : Int = zoneId.getOrElse({
-    membership.headOption match {
+    membership.lift(leaderPositionIndex) match {
       case Some(leader) =>
         leader.ZoneId
       case _ =>
@@ -45,13 +48,6 @@ class Squad(squadId : PlanetSideGUID, alignment : PlanetSideEmpire.Value) extend
     Task
   }
 
-  def Description : String = description
-
-  def Description_=(desc : String) : String = {
-    description = desc
-    Description
-  }
-
   def Listed : Boolean = listed
 
   def Listed_=(announce : Boolean) : Boolean = {
@@ -59,6 +55,20 @@ class Squad(squadId : PlanetSideGUID, alignment : PlanetSideEmpire.Value) extend
     Listed
   }
 
+  def LocationFollowsSquadLead : Boolean = locationFollowsSquadLead
+
+  def LocationFollowsSquadLead_=(follow : Boolean) : Boolean = {
+    locationFollowsSquadLead = follow
+    LocationFollowsSquadLead
+  }
+
+  def AutoApproveInvitationRequests : Boolean = autoApproveInvitationRequests
+
+  def AutoApproveInvitationRequests_=(autoApprove : Boolean) : Boolean = {
+    autoApproveInvitationRequests = autoApprove
+    AutoApproveInvitationRequests
+  }
+
   def Membership : Array[Member] = membership
 
   def Availability : Array[Boolean] = availability
@@ -85,3 +95,16 @@ class Squad(squadId : PlanetSideGUID, alignment : PlanetSideEmpire.Value) extend
 
   def Capacity : Int = availability.count(open => open)
 }
+
+object Squad {
+  final val Blank = new Squad(PlanetSideGUID(0), PlanetSideEmpire.NEUTRAL) {
+    override def ZoneId : Int = 0
+    override def ZoneId_=(id : Int) : Int = 0
+    override def ZoneId_=(id : Option[Int]) : Int = 0
+    override def Task_=(assignment : String) : String =  ""
+    override def Listed_=(announce : Boolean) : Boolean = false
+    override def Membership : Array[Member] = Array.empty[Member]
+    override def Availability : Array[Boolean] = Array.fill[Boolean](10)(false)
+    override def LeaderPositionIndex_=(position : Int) : Int = 0
+  }
+}
diff --git a/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala b/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala
index 40193730..7709a0d6 100644
--- a/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala
+++ b/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala
@@ -306,13 +306,13 @@ object SquadAction{
   * &nbsp;&nbsp;&nbsp;&nbsp;`36` - UNKNOWN<br>
   * &nbsp;&nbsp;`String :: Long :: Int :: Int`<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`34` - Search for Squads with a Particular Role
-  * @param unk1 na
-  * @param unk2 na
+  * @param squad_guid the unique identifier of the squad, if non-zero
+  * @param line the original listing line number, if applicable
   * @param action the purpose of this packet;
   *               also decides the content of the parameter fields
   */
-final case class SquadDefinitionActionMessage(unk1 : Int,
-                                              unk2 : Int,
+final case class SquadDefinitionActionMessage(squad_guid : PlanetSideGUID,
+                                              line : Int,
                                               action : SquadAction)
   extends PlanetSideGamePacket {
   type Packet = SquadDefinitionActionMessage
@@ -353,28 +353,28 @@ object SquadDefinitionActionMessage extends Marshallable[SquadDefinitionActionMe
       case 35 => cancelSquadSearchCodec
       case 40 => findLfsSoldiersForRoleCodec
       case 41 => cancelFindCodec
-      case 1 | 2 | 6 | 9 |
-           11 | 12 | 13 | 14 | 16 |
-           17 | 18 | 29 | 30 | 33 | 36 |
-           37 | 38 | 42 | 43 => unknownCodec(code)
+      case 1 | 2 | 6 | 9 | 11 |
+           12 | 13 | 14 | 16 | 17 |
+           18 | 29 | 30 | 32 | 33 |
+           36 | 37 | 38 | 42 | 43 => unknownCodec(code)
       case _ => failureCodec(code)
     }).asInstanceOf[Codec[SquadAction]]
   }
 
   implicit val codec : Codec[SquadDefinitionActionMessage] = (
     uintL(6) >>:~ { code =>
-      ("unk1" | uint16L) ::
-        ("unk2" | uint4L) ::
+      ("squad_guid" | PlanetSideGUID.codec) ::
+        ("line" | uint4L) ::
         ("action" | selectFromActionCode(code))
     }
     ).xmap[SquadDefinitionActionMessage] (
     {
-      case _ :: u1 :: u2 :: action :: HNil =>
-        SquadDefinitionActionMessage(u1, u2, action)
+      case _ :: guid :: line :: action :: HNil =>
+        SquadDefinitionActionMessage(guid, line, action)
     },
     {
-      case SquadDefinitionActionMessage(u1, u2, action) =>
-        action.code :: u1 :: u2 :: action :: HNil
+      case SquadDefinitionActionMessage(guid, line, action) =>
+        action.code :: guid :: line :: action :: HNil
     }
   )
 }
diff --git a/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala b/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
index 291ef219..418fbd2f 100644
--- a/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
+++ b/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
@@ -51,6 +51,8 @@ object SquadPositionDetail {
   def apply(role : String, detailed_orders : String, requirements : Set[CertificationType.Value]) : SquadPositionDetail = SquadPositionDetail(is_closed = false, role, detailed_orders, requirements, 0L, "")
 
   def apply(role : String, detailed_orders : String, name : String) : SquadPositionDetail = SquadPositionDetail(is_closed = false, role, detailed_orders, Set.empty, reliableNameHash(name), name)
+
+  def apply(role : String, detailed_orders : String, requirements : Set[CertificationType.Value], name : String) : SquadPositionDetail = SquadPositionDetail(is_closed = false, role, detailed_orders, requirements, reliableNameHash(name), name)
 }
 
 object SquadDetailDefinitionUpdateMessage extends Marshallable[SquadDetailDefinitionUpdateMessage] {
diff --git a/common/src/main/scala/net/psforever/packet/game/SquadMembershipRequest.scala b/common/src/main/scala/net/psforever/packet/game/SquadMembershipRequest.scala
index 55d73197..27cf2b79 100644
--- a/common/src/main/scala/net/psforever/packet/game/SquadMembershipRequest.scala
+++ b/common/src/main/scala/net/psforever/packet/game/SquadMembershipRequest.scala
@@ -28,7 +28,7 @@ final case class SquadMembershipRequest(request_type : SquadRequestType.Value,
       assert(unk3.nonEmpty, s"a $request_type request requires the unk3 field be defined")
   }
   if(request_type == SquadRequestType.Invite) {
-    assert(unk5.nonEmpty, "an Invite request requires the unk5 field be undefined")
+    assert(unk5.nonEmpty, "an Invite request requires the unk5 field be defined")
   }
 
   type Packet = SquadMembershipRequest
diff --git a/common/src/main/scala/services/teamwork/SquadResponse.scala b/common/src/main/scala/services/teamwork/SquadResponse.scala
index 09f05fb3..b898580b 100644
--- a/common/src/main/scala/services/teamwork/SquadResponse.scala
+++ b/common/src/main/scala/services/teamwork/SquadResponse.scala
@@ -1,7 +1,7 @@
 // Copyright (c) 2019 PSForever
 package services.teamwork
 
-import net.psforever.packet.game.SquadInfo
+import net.psforever.packet.game.{PlanetSideGUID, PlanetSideZoneID, SquadInfo, SquadPositionDetail}
 
 object SquadResponse {
   trait Response
@@ -9,4 +9,6 @@ object SquadResponse {
   final case class Init(info : Vector[SquadInfo]) extends Response
   final case class Update(infos : Iterable[(Int, SquadInfo)]) extends Response
   final case class Remove(infos : Iterable[Int]) extends Response
+
+  final case class Detail(guid : PlanetSideGUID, leader : String, task : String, zone : PlanetSideZoneID, member_info : List[SquadPositionDetail]) extends Response
 }
